Index: trunk/source/processes/electromagnetic/lowenergy/include/G4DNADingfelderChargeDecreaseModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4DNADingfelderChargeDecreaseModel.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4DNADingfelderChargeDecreaseModel.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4DNADingfelderChargeDecreaseModel.hh,v 1.1 2009/01/12 14:26:02 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4DNADingfelderChargeIncreaseModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4DNADingfelderChargeIncreaseModel.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4DNADingfelderChargeIncreaseModel.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4DNADingfelderChargeIncreaseModel.hh,v 1.1 2009/01/12 14:26:02 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4DNAElastic.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4DNAElastic.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4DNAElastic.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4DNAElastic.hh,v 1.2 2009/03/04 13:28:49 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4DNAEmfietzoglouExcitationModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4DNAEmfietzoglouExcitationModel.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4DNAEmfietzoglouExcitationModel.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4DNAEmfietzoglouExcitationModel.hh,v 1.1 2009/01/12 14:26:02 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4DNAExcitation.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4DNAExcitation.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4DNAExcitation.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4DNAExcitation.hh,v 1.2 2009/03/04 13:28:49 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4DNAGenericIonsManager.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4DNAGenericIonsManager.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4DNAGenericIonsManager.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4DNAGenericIonsManager.hh,v 1.4 2009/06/10 13:32:58 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #ifndef   G4DNAGENERICIONSMANAGER_HH
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4DNAIonisation.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4DNAIonisation.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4DNAIonisation.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4DNAIonisation.hh,v 1.3 2009/03/04 13:28:49 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4DNAMillerGreenExcitationModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4DNAMillerGreenExcitationModel.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4DNAMillerGreenExcitationModel.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4DNAMillerGreenExcitationModel.hh,v 1.1 2009/01/12 14:26:03 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4DNAProcess.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4DNAProcess.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4DNAProcess.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4DNAProcess.hh,v 1.5 2007/11/09 16:20:04 pia Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author:  Maria Grazia Pia (Maria.Grazia.Pia@ge.infn.it)
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4DNAProcess.icc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4DNAProcess.icc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4DNAProcess.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4DNAProcess.icc,v 1.12 2009/01/20 07:50:28 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 // 
 // Contact Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4DNARuddIonisationModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4DNARuddIonisationModel.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4DNARuddIonisationModel.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4DNARuddIonisationModel.hh,v 1.3 2009/06/26 09:42:32 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4DNAScreenedRutherfordElasticModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4DNAScreenedRutherfordElasticModel.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4DNAScreenedRutherfordElasticModel.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4DNAScreenedRutherfordElasticModel.hh,v 1.1 2009/01/12 14:26:03 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4DopplerProfile.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4DopplerProfile.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4DopplerProfile.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4DopplerProfile.hh,v 1.2 2008/03/17 13:45:25 pia Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4DummyFinalState.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4DummyFinalState.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4DummyFinalState.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4DummyFinalState.hh,v 1.2 2007/10/07 12:52:18 pia Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 // 
 // Contact Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4EMDataSet.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4EMDataSet.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4EMDataSet.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4EMDataSet.hh,v 1.13 2009/09/25 07:41:34 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateChargeDecrease.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateChargeDecrease.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateChargeDecrease.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4FinalStateChargeDecrease.hh,v 1.2 2008/07/14 20:47:34 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #ifndef G4FINALSTATECHARGEDECREASE_HH
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateChargeIncrease.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateChargeIncrease.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateChargeIncrease.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4FinalStateChargeIncrease.hh,v 1.2 2008/07/14 20:47:34 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #ifndef G4FINALSTATECHARGEIncrease_HH
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateChargeTransferProton.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateChargeTransferProton.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateChargeTransferProton.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FinalStateChargeTransferProton.hh,v 1.2 2008/03/25 16:00:20 pia Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 // 
 // Contact Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateElasticBrennerZaider.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateElasticBrennerZaider.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateElasticBrennerZaider.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4FinalStateElasticBrennerZaider.hh,v 1.2 2008/07/14 20:47:34 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #ifndef G4FINALSTATEELASTICBRENNERZAIDER_HH
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateElasticChampion.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateElasticChampion.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateElasticChampion.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4FinalStateElasticChampion.hh,v 1.1 2008/07/15 19:56:50 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 // -------------------------------------------------------------------
 
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateElasticScreenedRutherford.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateElasticScreenedRutherford.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateElasticScreenedRutherford.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4FinalStateElasticScreenedRutherford.hh,v 1.3 2008/07/14 20:47:34 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #ifndef G4FINALSTATEELASTICSCREENEDRUTHERFORD_HH
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateExcitationBorn.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateExcitationBorn.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateExcitationBorn.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4FinalStateExcitationBorn.hh,v 1.2 2008/07/14 20:47:34 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #ifndef G4FINALSTATEEXCITATIONBORN_HH
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateExcitationEmfietzoglou.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateExcitationEmfietzoglou.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateExcitationEmfietzoglou.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4FinalStateExcitationEmfietzoglou.hh,v 1.2 2008/07/14 20:47:34 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #ifndef G4FINALSTATEEXCITATIONEMFIETZOGLOU_HH
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateExcitationMillerGreen.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateExcitationMillerGreen.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateExcitationMillerGreen.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4FinalStateExcitationMillerGreen.hh,v 1.2 2008/07/14 20:47:34 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #ifndef G4FINALSTATEEXCITATIONMILLERGREEN_HH
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateIonisationBorn.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateIonisationBorn.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateIonisationBorn.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4FinalStateIonisationBorn.hh,v 1.4 2008/07/14 20:47:34 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #ifndef G4FINALSTATEIONISATIONBORN_HH
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateIonisationRudd.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateIonisationRudd.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateIonisationRudd.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4FinalStateIonisationRudd.hh,v 1.4 2008/07/14 20:47:34 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateKill.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateKill.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateKill.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FinalStateKill.hh,v 1.1 2007/11/09 20:26:47 pia Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 // 
 // Contact Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateProduct.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateProduct.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStateProduct.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FinalStateProduct.hh,v 1.5 2009/01/20 07:50:28 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 // 
 // Contact Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStatePsCreationChampion.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStatePsCreationChampion.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4FinalStatePsCreationChampion.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4FinalStatePsCreationChampion.hh,v 1.1 2008/07/16 19:01:07 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 // -------------------------------------------------------------------
 
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4FluoTransition.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4FluoTransition.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4FluoTransition.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FluoTransition.hh,v 1.2 ????
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Elena Guardincerri (Elena.Guardincerri@ge.infn.it)
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4IonParametrisedLossModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4IonParametrisedLossModel.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4IonParametrisedLossModel.hh	(revision 1228)
@@ -45,4 +45,11 @@
 //                               of heavy ions from ICRU 73 data
 //                20. 11. 2009 - Added set-method for energy loss limit (AL)
+//                24. 11. 2009 - Bug fix: Range calculation corrected if same 
+//                               materials appears with different cuts in diff.
+//                               regions (added UpdateRangeCache function and
+//                               modified BuildRangeVector, ComputeLossForStep
+//                               functions accordingly, added new cache param.,
+//                               changed typdef of IonMatCouple).
+//                             - Removed GetRange function (AL)  
 //
 // Class description:
@@ -75,7 +82,9 @@
 class G4VIonDEDXScalingAlgorithm;
 class G4LPhysicsFreeVector;
+class G4MaterialCutsCouple;
 
 typedef std::list<G4IonDEDXHandler*> LossTableList;
-typedef std::pair<const G4ParticleDefinition*, const G4Material*> IonMatCouple;
+typedef std::pair<const G4ParticleDefinition*, 
+                  const G4MaterialCutsCouple*> IonMatCouple;
 
 
@@ -121,8 +130,7 @@
    // range vs energy (and energy vs range) tables  
    G4double ComputeLossForStep(
-                                 const G4Material*, // Target material
+                                 const G4MaterialCutsCouple*, // Mat-cuts couple
 				 const G4ParticleDefinition*, // Projectile
 				 G4double,  // Kinetic energy of projectile
-                                 G4double,  // Energy cut for secondary prod.
 				 G4double); // Length of current step
 
@@ -157,8 +165,4 @@
 				 G4double&, 
 				 G4double); // Length of current step
-
-   G4double GetRange(const G4ParticleDefinition*, // Projectile
-		     const G4Material*,           // Target Material
-	             G4double);                   // Kinetic energy
 
    // Function which allows to add additional stopping power tables
@@ -219,4 +223,11 @@
                   G4double cutEnergy);           // Energy cut
 
+   // Function which updates parameters concerning the range calculation
+   // (the parameters are only updated if the particle, the material or 
+   // the associated energy cut has changed)
+   void UpdateRangeCache(
+                  const G4ParticleDefinition*,   // Projectile (ion) 
+                  const G4MaterialCutsCouple*);  // Target material
+
    // Function, which updates parameters concering particle properties
    void UpdateCache(
@@ -227,6 +238,5 @@
    void BuildRangeVector(
                   const G4ParticleDefinition*,   // Projectile (ion) 
-                  const G4Material*,             // Target material
-                  G4double);                     // Energy cut
+                  const G4MaterialCutsCouple*);  // Material cuts couple
 
    // Assignment operator and copy constructor are hidden:
@@ -329,4 +339,10 @@
    G4double cacheChargeSquare;                // Charge squared
 
+   // Cached parameters needed during range computations:
+   const G4ParticleDefinition* rangeCacheParticle; // Key: 1) Current ion,
+   const G4MaterialCutsCouple* rangeCacheMatCutsCouple; // 2) Mat-cuts-couple
+   G4PhysicsVector* rangeCacheEnergyRange;         // Energy vs range vector
+   G4PhysicsVector* rangeCacheRangeEnergy;         // Range vs energy vector
+
    // Cached parameters needed during dE/dx computations:
    const G4ParticleDefinition* dedxCacheParticle; // Key: 1) Current ion,
@@ -334,6 +350,4 @@
    G4double dedxCacheEnergyCut;                   //      3) cut energy 
    LossTableList::iterator dedxCacheIter;         // Responsible dE/dx table
-   G4PhysicsVector* dedxCacheEnergyRange;         // Energy vs range vector
-   G4PhysicsVector* dedxCacheRangeEnergy;         // Range vs energy vector
    G4double dedxCacheTransitionEnergy;      // Transition energy between
                                             // parameterization and 
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4LinInterpolation.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4LinInterpolation.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4LinInterpolation.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4LinInterpolation.hh,v 1.4 2009/09/25 07:41:34 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4LivermoreBremsstrahlungModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4LivermoreBremsstrahlungModel.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4LivermoreBremsstrahlungModel.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LivermoreBremsstrahlungModel.hh,v 1.2 2009/04/17 10:29:20 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Luciano Pandola
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4LivermoreComptonModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4LivermoreComptonModel.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4LivermoreComptonModel.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LivermoreComptonModel.hh,v 1.3 2009/04/17 10:29:20 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4LivermoreGammaConversionModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4LivermoreGammaConversionModel.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4LivermoreGammaConversionModel.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LivermoreGammaConversionModel.hh,v 1.3 2009/04/17 10:29:20 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4LivermoreIonisationModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4LivermoreIonisationModel.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4LivermoreIonisationModel.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LivermoreIonisationModel.hh,v 1.3 2009/10/23 09:28:37 pandola Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Luciano Pandola
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4LivermorePhotoElectricModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4LivermorePhotoElectricModel.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4LivermorePhotoElectricModel.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LivermorePhotoElectricModel.hh,v 1.3 2009/04/17 10:29:20 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4LivermorePolarizedComptonModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4LivermorePolarizedComptonModel.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4LivermorePolarizedComptonModel.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LivermorePolarizedComptonModel.hh,v 1.3 2009/05/02 15:20:52 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4LivermorePolarizedGammaConversionModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4LivermorePolarizedGammaConversionModel.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4LivermorePolarizedGammaConversionModel.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LivermorePolarizedGammaConversionModel.hh,v 1.1 2009/10/30 14:52:05 flongo Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4LivermorePolarizedPhotoElectricModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4LivermorePolarizedPhotoElectricModel.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4LivermorePolarizedPhotoElectricModel.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LivermorePolarizedPhotoElectricModel.hh,v 1.1 2009/10/30 14:52:05 flongo Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4LivermorePolarizedRayleighModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4LivermorePolarizedRayleighModel.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4LivermorePolarizedRayleighModel.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LivermorePolarizedRayleighModel.hh,v 1.3 2009/05/02 15:20:52 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4LivermoreRayleighModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4LivermoreRayleighModel.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4LivermoreRayleighModel.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LivermoreRayleighModel.hh,v 1.3 2009/04/17 10:29:20 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4LogLogInterpolation.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4LogLogInterpolation.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4LogLogInterpolation.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4LogLogInterpolation.hh,v 1.7 2009/09/25 07:41:34 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4LowEnergyBremsstrahlung.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4LowEnergyBremsstrahlung.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4LowEnergyBremsstrahlung.hh	(revision 1228)
@@ -27,5 +27,5 @@
 // -------------------------------------------------------------------
 // $Id: G4LowEnergyBremsstrahlung.hh,v 1.37 2006/06/29 19:35:55 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: A. Forti
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4LowEnergyCompton.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4LowEnergyCompton.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4LowEnergyCompton.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LowEnergyCompton.hh,v 1.24 2008/11/04 10:14:00 pandola Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: A. Forti
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4LowEnergyGammaConversion.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4LowEnergyGammaConversion.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4LowEnergyGammaConversion.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4LowEnergyGammaConversion.hh,v 1.15 2006/06/29 19:35:59 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: A. Forti
Index: trunk/source/processes/electromagnetic/lowenergy/include/G4LowEnergyIonisation.hh
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/include/G4LowEnergyIonisation.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/include/G4LowEnergyIonisation.hh	(revision 1228)
@@ -26,5 +26,5 @@
 // -------------------------------------------------------------------
 // $Id: G4LowEnergyIonisation.hh,v 1.41 2006/06/29 19:36:01 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: A. Forti
